
Ruby - Bug #7264

Error running miniruby: "vm_base_ptr: unreachable" on Mac OS X 10.7.4

11/02/2012 02:11 PM - lambda (Brian Campbell)

Status: Third Party's Issue   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version: 2.0.0   

ruby -v: 2.0.0-preview1 Backport:  

Description

=begin

I tried installing ruby-2.0.0-preview1 using rbenv install on Mac OS X 10.7.4. It crashed in miniruby while generating encdb.h

CC = gcc-4.2

LD = ld

LDSHARED = gcc-4.2 -dynamic -bundle

CFLAGS = -O3 -fno-fast-math -ggdb3 -Wall -Wextra -Wno-unused-parameter -Wno-parentheses -Wno-long-

long -Wno-missing-field-initializers -Wunused-variable -Werror=pointer-arith -Werror=write-strings

 -Werror=declaration-after-statement -Werror=shorten-64-to-32 -Werror=implicit-function-declaratio

n   -pipe 

XCFLAGS = -include ruby/config.h -include ruby/missing.h -D_FORTIFY_SOURCE=2 -fno-strict-overflow 

-fvisibility=hidden -DRUBY_EXPORT -fPIE

CPPFLAGS = -I'/Users/lambda/.rbenv/versions/2.0.0-preview1/include'  -D_XOPEN_SOURCE -D_DARWIN_C_S

OURCE -D_DARWIN_UNLIMITED_SELECT -D_REENTRANT   -I. -I.ext/include/x86_64-darwin11.4.0 -I./include

 -I.

DLDFLAGS = -Wl,-undefined,dynamic_lookup -Wl,-multiply_defined,suppress -Wl,-u,_objc_msgSend  

SOLIBS = 

 ...snip...

 linking miniruby

 generating encdb.h

 bp_check: 8, bp: 6

 <internal:prelude>:26: [BUG] vm_base_ptr: unreachable

 ruby 2.0.0dev (2012-11-01 trunk 37411) [x86_64-darwin11.4.0]

 

 -- Control frame information -----------------------------------------------

 c:0003 p:0031 s:0008 e:000007 CLASS  <internal:prelude>:26

 c:0002 p:0012 s:0004 e:000003 TOP    <internal:prelude>:17 [FINISH]

 c:0001 p:0000 s:0002 e:000438 TOP    [FINISH]

 

 <internal:prelude>:17:in `<compiled>'

 <internal:prelude>:26:in `<class:Thread>'

 

 bp_check: 8, bp: 6

 e information -------------------------------------------

 

 <internal:prelude>:26:  file under ~/Library/Logs/CrashReporter,

 /Library/Logs/CrashR[BUG] r, or /Library/Logs/DiagnosticReports, for

 the more detail of.

 

 m_base_ptr: unreachable-- Other runtime information ------------------------------------ Control 

frame information -----------------------------------------------

 * Loaded script: ./miniruby

 

 :0003 p:0031 d features:

 

 s:0008 numerator.so

 e[NOTE]

 YoCLASS have encountered a bug in the Ruby interpreter or extension libraries.

 Bug reports are welcome.

 For details: http://www.ruby-lang.org/bugreport.html
 <internal:prelude>:26

 c:0002 p:0012 s:0004 e:000003 TOP    <internal:prelude>:17 [FINISH]

 c:0001 p:0000 s:0002 e:002208 TOP    [FINISH]

 

 <internal:prelude>:17:in `<compiled>'

 <internal:prelude>:26:in `<class:Thread>'

 

 -- C level backtrace information -------------------------------------------

 

 See Crash Report log file under ~/Library/Logs/CrashReporter,

 /Library/Logs/CrashReporter, or /Library/Logs/DiagnosticReports, for

 the more detail of.

 

 -- Other runtime information -----------------------------------------------

 

 * Loaded script: ./miniruby

 

 * Loaded features:

 

 0 enumerator.so

 

 [NOTE]

 You may have encountered a bug in the Ruby interpreter or extension libraries.

 Bug reports are welcome.

 For details: http://www.ruby-lang.org/bugreport.html

 =end

History

#1 - 11/02/2012 07:13 PM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

- Assignee set to sorah (Sorah Fukumori)

- Target version set to 2.0.0

Thank you for the report!  Sorah will check it early next week.

--

Yusuke Endoh mame@tsg.ne.jp

#2 - 11/02/2012 11:27 PM - mame (Yusuke Endoh)

Bad news.  Nobu failed to reproduce this issue.

Could you try to build preview1 without ruby-build?

--

Yusuke Endoh mame@tsg.ne.jp

#3 - 11/03/2012 04:10 AM - lambda (Brian Campbell)

- File miniruby_2012-11-02-150443_erlang.crash added

- File ruby-log added

=begin

I can reproduce it doing the build manually with (({./configure; make})). Logs attached. gcc version:

erlang:ruby-2.0.0-preview1 lambda$ gcc-4.2 --version

i686-apple-darwin11-llvm-gcc-4.2 (GCC) 4.2.1 (Based on Apple Inc. build 5658) (LLVM build 2336.9.00)

Copyright (C) 2007 Free Software Foundation, Inc.

This is free software; see the source for copying conditions.  There is NO

warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

=end

#4 - 11/04/2012 08:16 AM - nobu (Nobuyoshi Nakada)

- Category set to core
- Assignee changed from sorah (Sorah Fukumori) to ko1 (Koichi Sasada)

#5 - 11/04/2012 07:41 PM - igor.alexandrov (Igor Alexandrov)

=begin

I've got this issue on OS X 10.8.2 with gcc-4.2

i686-apple-darwin11-llvm-gcc-4.2 (GCC) 4.2.1 (Based on Apple Inc. build 5658) (LLVM build 2336.11.00)

Copyright (C) 2007 Free Software Foundation, Inc.

This is free software; see the source for copying conditions.  There is NO

warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

Exporting CC helped me:

saturn:~$ export CC=clang

saturn:~$ rvm install ruby-2.0.0-preview1

No binary rubies available for: downloads/ruby-2.0.0-preview1.

Continuing with compilation. Please read 'rvm mount' to get more information on binary rubies.

Installing Ruby from source to: /Users/igor/.rvm/rubies/ruby-2.0.0-preview1, this may take a while depending on your cpu(s)...

ruby-2.0.0-preview1 - #downloading ruby-2.0.0-preview1, this may take a while depending on your connection...

ruby-2.0.0-preview1 - #extracting ruby-2.0.0-preview1 to /Users/igor/.rvm/src/ruby-2.0.0-preview1

ruby-2.0.0-preview1 - #extracted to /Users/igor/.rvm/src/ruby-2.0.0-preview1

ruby-2.0.0-preview1 - #configuring

ruby-2.0.0-preview1 - #compiling

ruby-2.0.0-preview1 - #installing

Removing old Rubygems files...

Installing rubygems-1.8.24 for ruby-2.0.0-preview1 ...

Installation of rubygems completed successfully.

Saving wrappers to '/Users/igor/.rvm/bin'.

ruby-2.0.0-preview1 - #adjusting #shebangs for (gem irb erb ri rdoc testrb rake).

ruby-2.0.0-preview1 - #importing default gemsets (/Users/igor/.rvm/gemsets/), this may take time ...

Install of ruby-2.0.0-preview1 - #complete

#6 - 11/05/2012 11:24 AM - sorah (Sorah Fukumori)

Reproduced with Lion &  default gcc: "i686-apple-darwin11-llvm-gcc-4.2 (GCC) 4.2.1 (Based on Apple Inc. build 5658) (LLVM build 2336.11.00)"

(comes from Command Line Tools (OS X Lion) for Xcode - October 2012, xcode451cltools_10_76938201a.dmg)

But can't with gcc-4.2 "i686-apple-darwin11-gcc-4.2.1 (GCC) 4.2.1 (Apple Inc. build 5666) (dot 3)"

#7 - 11/05/2012 11:53 AM - naruse (Yui NARUSE)

- Status changed from Assigned to Third Party's Issue

The gcc-4.2 is llvm-gcc, use clang.

If rbenv forces to use llvm-gcc, this issue should be reported to rbenv.

#8 - 11/05/2012 02:03 PM - sorah (Sorah Fukumori)

naruse (Yui NARUSE) wrote:

The gcc-4.2 is llvm-gcc, use clang.

If rbenv forces to use llvm-gcc, this issue should be reported to rbenv.

 try this:

CONFIGURE_OPTS="--use-gcc=clang" rbenv install …

Files

ruby-build.20121102002907.67411.log 326 KB 11/02/2012 lambda (Brian Campbell)

miniruby_2012-11-02-004312_erlang.crash 8.27 KB 11/02/2012 lambda (Brian Campbell)

miniruby_2012-11-02-004312-1_erlang.crash 8.27 KB 11/02/2012 lambda (Brian Campbell)

miniruby_2012-11-02-150443_erlang.crash 8.28 KB 11/03/2012 lambda (Brian Campbell)

ruby-log 20 KB 11/03/2012 lambda (Brian Campbell)
